/* mnl3r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;

/* Subroutine */ int mnl3r_c(integer *n, real *x, real *xmin, real *s,
        S_fp fun, S_fp grad, real *aa, real *bb, real *xe, real *ge,
        integer *i0, real *up, real *rm, integer *ierr)
{
    /* Initialized data */

    static real rs = 0.f;
    static real zero = 0.f;

    /* System generated locals */
    integer i__1;
    real r__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern /* Subroutine */ int mnl31_c(integer *, real *, real *, real *,
            real *, integer *, integer *),
            mnl32_c(integer *, real *, real *,
            real *, real *, integer *, integer *);
    static integer iter;
    static real a, b;
    static integer i__;
    static real v, w, z__, f1, f2;
    static integer i1, i2;
    static real g1, g2, fe, fv, gx;
    static integer iup1, iup2;

/*    OHOMEPHA MHMA YHK MHOX EPEMEHHX */
/*    O AAHHOMY HAPABEH  HA AAHHOM HTEPBAE */

/*    APAMETP: */
/*    N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX */
/*    X     -HAAHA TOKA OCKA */
/*    XMIN  -PACCTOHE OT X O BCEHHO TOK */
/*    S     -BEKTOP H N - HAPABEHE OCKA */
/*    FUN   -M OPOPAMM BCEH YHK */
/*    GRAD  -M OPOPAMM BCEH PAEHTA */
/*    AA,BB -HH  BEPXH PAH HTEPBAA, */
/*    XE    -TOHOCT O APYMEHTY */
/*    GE    -TOHOCT O PAEHTY */
/*    I    -KOPPEKTPY BEKTOP H N */
/*    UP    -BEKTOP YPABX APAMETPOB */
/*    RM    -PAO BEKTOP H 3N */
/*    IERR  -PHAK OKOHAH POECCA: */
/*          1 -OCTHYTA TOHOCT XE */
/*          3 -OCTHYTA TOHOCT GE */
/*          4 -BOHEHO UP(1) TEPA */
/*          65-GRAD HA EBOM KOHE OTPEKA .GE. */
/*              HA PABOM .LE. */
/*          66-BEKTOP S  I OPTOOHAH */

    /* Parameter adjustments */
    --rm;
    --up;
    --i0;
    --s;
    --x;

    /* Function Body */
    iup1 = up[1] + .5f;
    iup2 = up[2] + .5f;
    iter = 0;
    a = *aa;
    b = *bb;
    i1 = *n;
    i2 = *n << 1;

/*    BCEHE HOPM BEKTOPA S C YETOM I */

    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        if ((real) i0[i__] <= zero) {
            goto L10;
        }
/* Computing 2nd power */
        r__1 = s[i__];
        rs += r__1 * r__1;
L10:
        ;
    }
    if (rs > zero) {
        goto L20;
    }
    *ierr = 66;
    goto L160;
L20:
    rs = (real)sqrt(rs);
    mnl31_c(n, &x[1], &s[1], &a, &rm[1], &i0[1], &c__0);
    mnl31_c(n, &x[1], &s[1], &b, &rm[1], &i0[1], &i1);
    (*grad)(&rm[1], &rm[i2 + 1], ge, &i0[1]);
    mnl32_c(n, &rm[1], &s[1], &rs, &g1, &i0[1], &i2);
    (*grad)(&rm[i1 + 1], &rm[i2 + 1], ge, &i0[1]);
    mnl32_c(n, &rm[1], &s[1], &rs, &g2, &i0[1], &i2);

/*    POBEPKA HAKOB POBOHO HA KOHAX (A,B) */

    if (g1 >= zero || g2 <= zero) {
        goto L90;
    }

/*    POBEPKA H KOHTPOHOO OTPEKA */

    if ((b - a) * .5f <= *xe) {
        goto L100;
    }
    (*fun)(&rm[1], &f1, &fe);
    (*fun)(&rm[i1 + 1], &f2, &fe);
L30:
    ++iter;

/*    POBEPKA CA TEPA */

    if (iter >= iup1) {
        goto L120;
    }

/*    POBEPKA H KOHTPOHOO OTPEKA */

    if ((b - a) * .5f <= *xe) {
        goto L100;
    }

/*    BCEHE POMEYTOHO TOK (A,B) */

    switch (iup2) {
        case 1:  goto L40;
        case 2:  goto L50;
        case 3:  goto L60;
    }
L40:
    v = (f1 - f2 + b * g2 - a * g1) / (g2 - g1);
    goto L70;
L50:
    v = (b * g2 - a * g1) / (g2 - g1);
    goto L70;
L60:
    z__ = (f1 - f2) * 3.f / (b - a);
    z__ = z__ + g1 + g2;
    w = z__ * z__ - g1 * g2;
    w = (real)sqrt(w);
    v = (z__ + g2 - w) * (b - a) / (g2 + g1 + z__ * 2);
    v = b - v;
L70:
    mnl31_c(n, &x[1], &s[1], &v, &rm[1], &i0[1], &c__0);
    (*grad)(&rm[1], &rm[i2 + 1], ge, &i0[1]);
    mnl32_c(n, &rm[1], &s[1], &rs, &gx, &i0[1], &i2);
    (*fun)(&rm[1], &fv, &fe);
    if (gx <= *ge) {
        goto L80;
    }

/*    CTAPOE V CTAHOBTC HOBM B */

    b = v;
    f2 = fv;
    g2 = gx;
    goto L30;
L80:
    if (gx >= -(*ge)) {
        goto L130;
    }

/*    CTAPOE V CTAHOBTC HOBM A */

    a = v;
    f1 = fv;
    g1 = gx;
    goto L30;

/*    OPEEEHE BXOHX APAMETPOB */

L90:
    *ierr = 65;
    goto L140;
L100:
    *ierr = 1;
    goto L140;
/* L110: */
    *ierr = 2;
    goto L140;
L120:
    *ierr = 4;
    goto L140;
L130:
    *ierr = 3;
    *xmin = v;
    goto L160;
L140:
    if (f1 > f2) {
        goto L150;
    }
    *xmin = a;
    goto L160;
L150:
    *xmin = b;
L160:
    return 0;
} /* mnl3r_c */
